﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;

using System.Data;
using System.Data.SqlClient;
using System.Configuration;
using System.Windows.Forms.DataVisualization.Charting;
namespace Pie_Chart_Windows_Forms_CS
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //Fetch the Statistical data from database.
            string query = "SELECT ShipCountry, DATEPART(Year, OrderDate) [Year], COUNT(OrderId) [Total]";
            query += " FROM Orders WHERE ShipCountry IN ('France', 'Germany', 'Brazil')";
            query += " GROUP BY ShipCountry, DATEPART(Year, OrderDate)";
            DataTable dt = GetData(query);

            //Get the DISTINCT Countries.
            List<string> countries = (from p in dt.AsEnumerable()
                                      select p.Field<string>("ShipCountry")).Distinct().ToList();

            //Remove the Default Series.
            if (Chart1.Series.Count() == 1)
            {
                Chart1.Series.Remove(Chart1.Series[0]);
            }

            //Loop through the Countries.
            foreach (string country in countries)
            {

                //Get the Year for each Country.
                int[] x = (from p in dt.AsEnumerable()
                           where p.Field<string>("ShipCountry") == country
                           orderby p.Field<int>("Year") ascending
                           select p.Field<int>("Year")).ToArray();

                //Get the Total of Orders for each Country.
                int[] y = (from p in dt.AsEnumerable()
                           where p.Field<string>("ShipCountry") == country
                           orderby p.Field<int>("Year") ascending
                           select p.Field<int>("Total")).ToArray();



                //Add Series to the Chart.
                Chart1.Series.Add(new Series(country));
                Chart1.Series[country].IsValueShownAsLabel = true;
                Chart1.Series[country].BorderWidth = 3;
                Chart1.Series[country].ChartType = SeriesChartType.Line;
                Chart1.Series[country].Points.DataBindXY(x, y);
            }

            Chart1.Legends[0].Enabled = true;
        }

        private static DataTable GetData(string query)
        {
            string constr = @"Data Source=.\SQL2005;Initial Catalog=Northwind;User ID=sa;Password=pass@123";
            using (SqlConnection con = new SqlConnection(constr))
            {
                using (SqlDataAdapter sda = new SqlDataAdapter(query, con))
                {
                    DataTable dt = new DataTable();
                    sda.Fill(dt);
                    return dt;
                }
            }
        }
    }
}
